# $Id: Archive.pm 867 2006-04-11 20:34:56Z guillomovitch $
package Youri::Upload::Action::Archive;

=head1 NAME

Youri::Upload::Action::Archive - Old revisions archiving

=head1 DESCRIPTION

This action plugin ensures archiving of old package revisions.

=cut

use warnings;
use strict;
use Carp;
use base qw/Youri::Upload::Action/;

sub _init {
    my $self   = shift;
    my %options = (
        perms => 644,
        @_
    );

    $self->{_perms} = $options{perms};
}

sub run {
    my ($self, $package, $repository, $target, $define) = @_;
    croak "Not a class method" unless ref $self;

    foreach my $replaced_package (
        $repository->get_replaced_packages($package, $target, $define)
    ) {
        my $file = $replaced_package->get_file();
        my $dest = $repository->get_archive_dir($package, $target, $define);

        print "archiving file $file to $dest\n" if $self->{_verbose};

        unless ($self->{_test}) {
            # create destination dir if needed
            system("install -d -m " . ($self->{_perms} + 111) . " $dest")
                unless -d $dest;

            # install file to new location
            system("install -m $self->{_perms} $file $dest");
        }
    }
}

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2002-2006, YOURI project

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

=cut

1;
