# $Id: /local/youri/soft/trunk/lib/Youri/Upload/Check/Tag.pm 1642 2006-03-29T06:49:43.840267Z guillaume  $
package Youri::Upload::Check::Type;

=head1 NAME

Youri::Upload::Check::Type - Type check

=head1 DESCRIPTION

This check plugin rejects packages with incorrect type.

=cut

use warnings;
use strict;
use Carp;
use base qw/Youri::Upload::Check/;

sub _init {
    my $self   = shift;
    my %options = (
        type => undef, # expected type
        @_
    );

    croak "no type to check" unless $options{type};
    croak "invalid type value" unless $options{type} =~ /^(?:source|binary)$/;

    $self->{_type} = $options{type};
}

sub run {
    my ($self, $package, $repository, $target, $define) = @_;
    croak "Not a class method" unless ref $self;

    my $type = $package->get_type();
    if ($type ne $self->{_type}) {
        $self->{_error} = "invalid type $type";
        return 0;
    }

    return 1;
}

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2002-2006, YOURI project

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

=cut

1;
